/*
  Residentes <- Empregados <- Professores
*/
#include "residentes.hpp"

using namespace std; 

// Empregado classe derivada publicamente da classe Residente
class Empregado : public Residente {
public:
  // construtor sem argumentos
  Empregado();// : Residente();

  /*
    Construtor com três argumentos, dois deles são passados
    directamente ao construtor da classe   
  */
  Empregado(string, unsigned long, unsigned long);

  /*
    Fixa (após inicialização) a informação respeitante a um Empregado
    
    Pre: o objecto já foi inicializado (construtor)
    Post: fixa (ou actualiza) a informação de um Empregado.
  */
  void fixaInfo(string, unsigned long, unsigned long); 


  /*
    Mostra a informação respeitante a um Empregado
    
    Pre: A informação de Empregado já está definida.
    Post: Mostra a informação de um Empregado.
  */
  void mostraInfo(); 
protected:
  unsigned long numEmpr;
};   
                  
// Professor classe derivada publicamente da classe Empregado 
class Professor : public Empregado {
public:
  // construtor sem argumentos
  Professor();
  // Construtor com cinco argumentos, três deles são passados
  // directamente ao construtor da classe base
  Professor(string, unsigned long, unsigned long, string, unsigned int);

  /*
    Fixa (após inicialização) a informação respeitante a um Professor
    
    Pre: o objecto já foi inicializado (construtor)
    Post: fixa (ou actualiza) a informação de um Professor
  */
  void fixaInfo(string, unsigned long, unsigned long, string, unsigned int);

  /*
    Mostra a Informação respeitante a um Professor
    
    Pre: A informação de um Professor já está definida.
    Post: Mostra a informação de um Professor
  */
  void mostraInfo();
protected:             
  string especializacao;
  int numOrientacoes;
};            
