#include <iostream>  
#include "residentes.hpp"
#include "estudantes.hpp"

using namespace std; 

/*
  Estudante - classe derivada publicamente de Residente
*/

Estudante::Estudante() : Residente() {}; 

Estudante::Estudante(string _nome, unsigned long _cc, string _nomeDep, unsigned long _numAluno) 
    : Residente(_nome, _cc) { 
    nomeDep = _nomeDep; // guarda o nome do Departamento
    numAluno = _numAluno; // guarda o número de aluno
  };

void Estudante::fixaInfo(string _nome, unsigned long _cc, string _nomeDep, unsigned long _numAluno) {
  Residente::fixaInfo(_nome, _cc);
  nomeDep = _nomeDep; // actualiza o nome do Departamento
  numAluno = _numAluno; // actualiza o número de aluno
}

void Estudante::mostraInfo() {
  Residente::mostraInfo();
  cout << "\nNome do Departmento: " << nomeDep;
  cout << "\nNúmero de Estudante: " << numAluno << endl;
}

/*
  EstudanteMestDout classe derivada publicamente da classe
  Estudante
*/

EstudanteMestDout::EstudanteMestDout() : Estudante() {} ;

EstudanteMestDout::EstudanteMestDout(string _nome, unsigned long _cc, string _nomeDep, 
				     unsigned long _numAluno, string _nomePrg, 
				     string _supervisor) 
  : Estudante(_nome, _cc, _nomeDep,  _numAluno){
  nomePrg = _nomePrg; // Guarda o nome do Departamento
  supervisor = _supervisor; // Guarda o número de aluno
};

void EstudanteMestDout::fixaInfo(string _nome, unsigned long _cc, string _nomeDep, 
				 unsigned long _numAluno, string _nomePrg, 
				 string _supervisor) {
  Estudante::fixaInfo(_nome, _cc, _nomeDep,  _numAluno);
  nomePrg = _nomePrg;
  supervisor = _supervisor;
}

void EstudanteMestDout::mostraInfo() {
  Estudante::mostraInfo();
  cout << "\nNome Programa (Mestrado/Doutoramento): " << nomePrg;
  cout << "\nSupervisor: " << supervisor;
}
