/*
  Residentes <- Empregados <- Professores
*/
#include <iostream>  
#include "residentes.hpp"

using namespace std; 

//Estudante classe derivada publicamente de Residente
class Estudante : public Residente  {
public:
  // construtor sem argumentos
  Estudante();

  // Construtor com quatro argumentos, dois deles são passados
  // directamente ao construtor da classe base
  Estudante(string, unsigned long, string, unsigned long); 

  /*
    Fixa (após inicialização) a informação respeitante a um Estudante
    
    Pre: o objecto já foi inicializado (construtor)
    Post: fixa (actualiza) a informação de um Estudante
  */ 
  void fixaInfo(string, unsigned long, string, unsigned long) ;

  /*
    Mostra a Informação respeitante a um Estudante
    
    Pre: A informação de um Estudante já está definida.
    Post: Mostra a informação de um Estudante
  */ 
  void mostraInfo() ;
protected:             
  string nomeDep;
  unsigned long numAluno;
};

/*
  EstudanteMestDout classe derivada publicamente da classe
  Estudante
*/
class EstudanteMestDout : public Estudante {
public:
  // construtor sem argumentos
  EstudanteMestDout();
  // Construtor com seis argumentos, três deles são passados
  // directamente ao construtor da classe base
  EstudanteMestDout(string, unsigned long, string, unsigned long, string, string);


  /*
    Fixa (após inicialização) a informação respeitante a um Estudante
    de Mestrado/Doutoramento
    
    Pre: o objecto já foi inicializado (construtor) 
    Post: fixa (actualiza) a informação de um Estudante de
          Mestrado/Doutoramento
  */ 
  void fixaInfo(string, unsigned long, string, unsigned long, string, string) ;

  /*
    Mostra a Informação respeitante a um Estudante de Mestrado ou
    Doutoramento
    
    Pre: A informação de um Estudante já está definida.
    Post: Mostra a informação de um Estudante
  */
  void mostraInfo();
protected:             
  string nomePrg;
  string supervisor;
}; 
