#ifndef RESIDENTES
#define RESIDENTES

/*
  Residentes <- Empregados <- Professores
*/
#include <iostream>  

using namespace std; 

class Residente {
public:
  // construtor sem argumentos
  Residente();  
  /* construtor com dois argumentos
     Pre: Sem pré-requesitos
     Post: Definição da informação de um residente (nome e número de
     Cartão de Cidadão).
  */
  Residente(string, unsigned long);

  /*
    Fixa (após) inicialização a informação de um residente.
    
    Pre:  o objecto já foi inicializado (construtor)
    Post: fixa (ou actualiza) a informação de um Residente.
  */ 
  void fixaInfo(string, unsigned long);

  /*
    Mostra a informação de um residente.
    
    Pre: A informação de um Residente já está definida.
    Post: Mostra a informação de um Residente.
  */ 
  void mostraInfo();
protected:
  string nome; // Nome do Residente
  unsigned long cc; // CC do Residente
};  

#endif
